Loading...
Searching...
No Matches
Swagger::OperationObject Class Reference

Describes a single API operation on a path. More...

Inheritance diagram for Swagger::OperationObject:
[legend]

## Public Member Functions

| constructor (string path, string method, hash< auto > oh, SwaggerSchema swagger)
| Constructor.
*data | getRequestBody (PathItemObject pio, auto body, reference< hash< auto > > headers)
| Processes a generated request.
hash< string, AbstractParameterObject > | parameters ()
| A hash of parameters that are applicable for this operation.
| validateRequest (bool serialize, PathItemObject pio, reference< hash< UriQueryInfo > > h, reference< auto > body, reference< hash > headers, *reference< hash< string, bool > > mime_types)
| processes a REST API client-side request to the operation
Public Member Functions inherited from Swagger::ObjectBase
| constructor ()
| Constructor.
| constructor (hash< auto > oh)
| Constructor.
| constructor (ObjectBase other)
| copy constructor
| initialize (hash< auto > oh)
| Initialize.

## Public Attributes

AbstractParameterObject | body
| body parameter; if defined for this operation, formData parameter will be excluded
hash< string, bool > | consumes
| A list of MIME types (strings) the operation can consume.
bool | deprec = False
| Declares this operation to be deprecated.
*string | desc
| A verbose explanation of the operation behavior. GFM syntax can be used for rich text representation.
*ExternalDocumentationObject | externalDocs
| Additional external documentation for this operation.
hash< string, AbstractParameterObject > | formData
| formData parameter; if defined for this operation, body parameter will be excluded
string | method
| the HTTP method for the operation
*string | operationId
| Unique string used to identify the operation.
string | path
| the URI path for the operation
hash< string, bool > | produces
| A hash of MIME types (strings) the operation can produce.
ResponsesObject | responses
| Required. The list of possible responses as they are returned from executing this operation.
list< string > | schemes
| The transfer protocol for the operation.
list< hash< string, list< string > > > | security
| A declaration of which security schemes are applied for this operation.
*string | summary
| A short summary of what the operation does.
list | tags
| A list of tags (strings or TagObjects) for API documentation control.
Public Attributes inherited from Swagger::ObjectBase
hash< auto > | vendorExtensions
| Allows extensions to the Swagger Schema.

## Detailed Description

Describes a single API operation on a path.

## Member Function Documentation

## constructor()

Swagger::OperationObject::constructor | ( | string | path,
|  | string | method,
|  | hash< auto > | oh,
|  | SwaggerSchema | swagger
| ) |  |

Constructor.

Parameters

  path | the path for the operation
  method | the HTTP method for the operation
  oh | deserialized hash from the source schema description describing the operation
  swagger | the REST schema for resolving references

Exceptions

  INVALID-FIELD-TYPE | field has invalid type
  INVALID-FIELD-VALUE | field has invalid value
  REQUIRED-FIELD-MISSING | required field is missing

## parameters()

hash< string, AbstractParameterObject > Swagger::OperationObject::parameters | ( |  | ) |

A hash of parameters that are applicable for this operation.

If a parameter is already defined at the Path Item, the new definition will override it, but can never remove it. The hash MUST NOT include duplicated parameters. A unique parameter is defined by a combination of a name and location. There can be one "body" parameter at most.

## validateRequest()

Swagger::OperationObject::validateRequest | ( | bool | serialize,
|  | PathItemObject | pio,
|  | reference< hash< UriQueryInfo > > | h,
|  | reference< auto > | body,
|  | reference< hash > | headers,
|  | *reference< hash< string, bool > > | mime_types
| ) |  |

inline

processes a REST API client-side request to the operation

Parameters

  serialize | if request arguments should be processed for serialization (client-side) or not (server-side)
  pio | the PathItemObject corresponding to the URI path
  h | a reference to the URI query info hash
  body | a reference to the deserialized HTTP message body data
  headers | a reference to a hash of HTTP headers
  mime_types | a reference to a hash of valid mime types for the operation

Exceptions

  SCHEMA-VALIDATION-ERROR | invalid parameter name or location, missing parameter and parameter has no default value

## Member Data Documentation

## consumes

hash<string, bool> Swagger::OperationObject::consumes

A list of MIME types (strings) the operation can consume.

This overrides the consumes definition at the Swagger Object. An empty value MAY be used to clear the global definition. Key values MUST be Mime Types.

## deprec

bool Swagger::OperationObject::deprec = False

Declares this operation to be deprecated.

Usage of the declared operation should be refrained. Default value is `false`.

## operationId

*string Swagger::OperationObject::operationId

Unique string used to identify the operation.

The id MUST be unique among all operations described in the API. Tools and libraries MAY use the operationId to uniquely identify an operation, therefore, it is recommended to follow common programming naming conventions.

## produces

hash<string, bool> Swagger::OperationObject::produces

A hash of MIME types (strings) the operation can produce.

This overrides the produces definition at the Swagger Object. An empty value MAY be used to clear the global definition. Key values MUST be Mime Types.

## schemes

list<string> Swagger::OperationObject::schemes

The transfer protocol for the operation.

Values MUST be from the list: `"http"`, `"https"`, `"ws"`, `"wss"`. The value overrides the SwaggerSchema schemes definition.

## security

list<hash<string, list<string> > > Swagger::OperationObject::security

A declaration of which security schemes are applied for this operation.

The list of values describes alternative security schemes that can be used (that is, there is a logical OR between the security requirements). This definition overrides any declared top-level security. To remove a top-level security declaration, an empty array can be used.

Individual values are hashes in the form of Security Requirement Objects. See https://github.com/OAI/OpenAPI-Specification/blob/master/versions/2.0.md#securityRequirementObject. That is, the hash keys MUST correspond to security schemes declared in the Security Definitions, while the values are lists of scope names (strings) required for the execution.

## tags

list Swagger::OperationObject::tags

A list of tags (strings or TagObjects) for API documentation control.

Tags can be used for logical grouping of operations by resources or any other qualifier.